As the architecture is not yet available, we use a cycle-accurate simulator that we run on a virtual machine to conduct the experiments. % \fixme{ \LAD{} \SB{} give more details about simulator }

% For the followings, we first present the metrics used during the evaluation.
Firstly, we will give some details about the datasets used to perform the experiments.
Secondly, we will give an overview of some existing implementations of the $k$-means algorithm
that we can use as a comparison.
Finally, we will give the specifications of the virtual machine we used to conduct the experiments.

% \subsubsection{Evaluation Metrics}

% The aim is to evaluate both the quality of the clustering and the runtime of the program.
% To this end, we introduce two metrics.

% \paragraph{Clustering quality}

% We denote by $C = \left( c_1 \ldots c_k \right)$ the centroids of the $k$ clusters.
% We also denote by $C_i$ the cluster whose centroid is $c_i$.
% The $k$-means problem consists in minimizing the within-cluster sum of squares, i.e.

% \[ \argmin_{C} \sum_{i=1}^{k} \sum_{p \in C_i} \mathrm{d}(p, c_i) \]

% We thus define the following quality function:

% \[ f : C \mapsto \sum_{i=1}^{k} \sum_{p \in C_i} \mathrm{d}(p, c_i) \]

% Given two algorithms $A$ and $B$, and their results respectively $C_A$ and $C_B$,
% we can compare $f(C_A)$ and $f(C_B)$ to determine which one
% returned the best result in terms of clustering quality.

% \paragraph{Runtime}

% To evaluate the efficiency of our implementation in terms of runtime,
% we use speed up metric.

% Given two algorithms $A$ and $B$ which takes respectively $RT_A$ and $RT_B$ to run the same task, speed up is defined as follows:

% \[ \emph{SpeedUp}\left(A, B \right) = \frac{RT_A}{RT_B} \]

% This measures how much faster algorithm $B$ is, compared to algorithm $A$.


\subsubsection{Datasets}

We consider a set of $n$ points with $d$ coordinates.
A dataset is thus a subset of $\mathbb{R}^{n \times d}$.

As the \upmem{} hardware only accepts integer operations, we only consider datasets with integer coordinates.
Experiments with floats could however be performed as further work, using a software library to emulate floating operations.
We consider datasets with different characteristics in terms of number of points and dimension value.
Experiments are performed with randomly generated datasets.

%\paragraph{Randomly generated dataset}

We generate random datasets using the following protocol:
\begin{enumerate}
\item We first compute $k$ random points uniformly in an hypercube of edge of size $1024$, these points will be used as centroid for clusters.
\item We add a point to the dataset by first choosing randomly one of the clusters, and then generating the point around it with a Gaussian distribution.
\item We thus obtain some float coordinates that we convert to integers.
\end{enumerate}
This way, we obtain a dataset for which the result of the $k$-means algorithm is meaningful.

We chose different characteristics and seeds to select three random datasets,
to use during evaluation.
These are described in \tablename~\ref{tab:random}.

\begin{table}
    \centering
    \begin{tabular}{|c|c|c|c|}
    \hline
    Name & Number of points & Dimension & Value used for $k$ \\
    \hline
    \textsc{Random-0} & 500000 & 34 & 3 \\
    \hline
    \textsc{Random-1} & 1000000 & 10 & 5 \\
    \hline
    \textsc{Random-2} & 100000 & 2 & 10 \\
    \hline
    \end{tabular}
    \caption{Characteristics of random datasets}
\label{tab:random}
\end{table}

%\paragraph{Real datasets}


\subsubsection{Reference implementations}
\label{sec:ref_implem}

We aim to compare our program with some existing $k$-means implementations.
Thus we give an overview of those we selected to perform this evaluation.

\cite{implemMPI} gives a sequential $k$-means program written in C, as well as a parallel program using MPI\@.
Message Passing Interface (MPI) is a standard library that allows to exchange messages between processes or nodes,
and that is widely used for parallel computing.

\cite{implemHadoop} uses the Hadoop framework, which is an open source implementation of MapReduce, a powerful parallel programming technique.~\cite{ahmad2012puma} provides a benchmark for \kmeans.

Finally,~\cite{implemCuda} gives a GPU implementation that uses the Cuda platform.

\subsubsection{Virtual Machine specifications}
\label{sec:vm_characteristics}
The experiments are conducted on a virtual machine (QEMU Virtual CPU version (cpu64-rhel6), 4 cores 2.4 MHz, 4 GBytes RAM) configuration running Linux Fedora 20.
All experiments are conducted on this architecture.
Note that the simulator is taking some extra space into the main memory, thus we need to check that this does not affect the overall computation time.
Firstly, we ensured that this does not induce extra swap accesses.
Secondly, the time-consuming part is the tasklet computation which runs on the simulator.
Therefore it cannot be affected, and a little increase of the host computation time would not be significant in the overall computation time.

